
package ejer1;

import java.util.LinkedList;

public class NodoEnteros {

	Integer info;
	NodoEnteros left;
	NodoEnteros right;

	// M�todos b�sicos

	public NodoEnteros(Integer info) {
		this.info = info;
	}

	// Devuelve si el nodo es hoja
	public boolean isLeaf() {
		return (left == null && right == null);
	}

	// Devuelve si el nodo tiene sub�rbol izquierdo
	public boolean hasLeft() {
		return (left != null);
	}

	// Devuelve si el nodo tiene sub�rbol derecho
	public boolean hasRight() {
		return (right != null);
	}
	

	// EJERCICIO 1: esEquiponderado
	
		//TO DO
/*	public boolean esEquiponderado() {
		if(this.isLeaf()) return true;
		else {
			if(this.hasLeft() && this.hasRight()) {
				int sumIzq = sumaSubarbol(this.left);
				int sumDer = sumaSubarbol(this.right);
				if(sumIzq==sumDer) {
					return this.left.esEquiponderado() && this.right.esEquiponderado();
				}
				else return false;
			}
			else return false;
		}
	}
	
	public int sumaSubarbol(NodoEnteros nodo) {
        if (nodo == null) {
            return 0;
        }
        int sumaIzq=sumaSubarbol(nodo.left);
        int sumaDer=sumaSubarbol(nodo.right);
        return nodo.info+sumaIzq+sumaDer;
    }
	
	*/
	
	public ResultadoEsEquiponderado esEquiponderado() {
		if(this.isLeaf()) return new ResultadoEsEquiponderado(true,this.info);
		else {
			if(this.hasLeft() && this.hasRight()) {
				ResultadoEsEquiponderado resIzq= this.left.esEquiponderado();
				ResultadoEsEquiponderado resDer= this.right.esEquiponderado();
				int suma= this.info+resIzq.getSuma()+resDer.getSuma();
				if(resIzq.getEsEquiponderado() && resDer.getEsEquiponderado()) {
					if(resIzq.getSuma()==resDer.getSuma()) {
						return new ResultadoEsEquiponderado(true,suma);
					}
					else return new ResultadoEsEquiponderado(false,suma);
				}
			}
			else return new ResultadoEsEquiponderado(false,33);
		}
		return new ResultadoEsEquiponderado(false,33);
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	//M�todos auxiliares para pruebas
	public LinkedList<Integer> elementosEnInOrden() {
		LinkedList<Integer> resultado = new LinkedList<Integer>();
		if (this.hasLeft()) resultado.addAll(this.left.elementosEnInOrden());
		resultado.addLast(info);
		if (this.hasRight()) resultado.addAll(this.right.elementosEnInOrden());
		return resultado;
	}
	
	public void imprimirArbol() {
		if(this.isLeaf()) System.out.print("[ "+this.info+" ] ");
		else {
			System.out.print("[ "+info+" ");
			if(this.hasLeft()) this.left.imprimirArbol();
			else System.out.print("* ");
			if(this.hasRight()) this.right.imprimirArbol();
			else System.out.print("* ");
			System.out.print("] ");
		}		
	}

	
}